/*
 * Component: sr
 *
 * Description:
 *  Header file containing the definition of IMPbDDocument object
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */
#ifndef IM_PBD_DOCUMENT_H_INCLUDED
#define IM_PBD_DOCUMENT_H_INCLUDED

#include <stdio.h>

// #include <dcmtk/config/osconfig.h>
#include <dcmtk/dcmdata/dctk.h>

#include "IMDocument.h"

class IMPbDDocument : public IMDocument {
	private:
		DcmSequenceOfItems * m_dictationSequence;

		OFBool isNotDemographyTag( DcmTagKey & tag );

		void dumpItem( FILE * output, DcmItem * item, int ndx );
		void writeToFile( DcmItem * item, const char * wavePrefix );

	public:
		IMPbDDocument();
		IMPbDDocument( const char * filename );
		virtual ~ IMPbDDocument();

		virtual E_IMDocType getIdent() const {
			return IMDocPbD;
		}

		virtual void load( const char * timezone = NULL );
		virtual void createNew( const char * studyIUID );

		void getSopInstanceUID( DcmItem * item, char *& value );
		OFBool addNewDictationItem( DcmItem * dictationItem );
		OFBool modifyDictationItem( DcmItem * modificationItem );
		OFBool modifyItem( DcmItem * item, DcmItem * modificationItem );
		DcmItem * getOrCreateItemFor( const char * sopIUID );
		void modifyDemography( DcmItem * item );

		void removeDictationItem( const char * dictationUID );
		OFBool hasDictationItem();

		void dump( FILE * output );
		void writeToFile( const char * wavePrefix );

		void getPBLastModifiedDateTime( char *& lmdate, char *& lmtime );
};

#endif								  // IM_PBD_DOCUMENT_H_INCLUDED
