/*
 * Component: sr
 *
 * Description:
 *  Header file containing the definition of SRDisplay class.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */
#ifndef __SR_DISPLAY_H_INCLUDED__
#define __SR_DISPLAY_H_INCLUDED__

// #include <dcmtk/config/osconfig.h>
#include <dcmtk/ofstd/ofstd.h>
#include <dcmtk/dcmsr/dsrdoc.h>
#include <dcmtk/dcmsr/dsrstrvl.h>

class SRDisplay:public DSRTypes {
 private:
	OFString m_filename;
	DcmFileFormat m_fileformat;
	DSRDocument m_document;
	DSRDocumentTree & m_tree;

	OFString m_author;

	OFString m_reportString;


	bool load();
	void append( OFString & text, const char * prefix, const char * name, const char * value );
	void calcAuthor( OFString & observationDateTime );

	void appendFlags( OFString & text, const char * prefix );


 public:
	SRDisplay( const char * filename );
	~SRDisplay();

	inline const OFString & getReportString() const {
		return m_reportString;
	}

	bool generateReportString( int num );
};

#endif								  // __SR_DISPLAY_H_INCLUDED__
