/*
 * annotation.h
 *
 *  Created on: Aug 28, 2013
 *      Author: tnemeth
 */

#ifndef ANNOTATION_H_
#define ANNOTATION_H_


namespace impsconverter {

class PresentationState;

class Annotation {
	protected:
		/** Annotation index */
		int m_index;

		/** Annotation color (as displayed in eRAD viewer) */
		OFString m_color;

		/** Indicates whether index to be displayed or not (in eRAD viewer) */
		bool m_showIndex;

		/** Indicates whether value to be displayed or not (in eRAD viewer) */
		bool m_showValue;

		/** Base point of the annotation - X coordinate (column) */
		int m_baseX;
		/** Base point of the annotation - Y coordinate (row) */
		int m_baseY;

		/** Base (anchor) point of the index - X coordinate (column) */
		int m_indexX;
		/** Base (anchor) point of the index - Y coordinate (column) */
		int m_indexY;

		/** Base (anchor) point of the value - X coordinate (column) of the center of the text */
		int m_valueX;
		/** Base (anchor) point of the value - Y coordinate (row) of the center of the text */
		int m_valueY;

		/** orientation of the annotation */
		int m_orientation;

		/** true indicates to print debug messages */
		bool m_debug;

		PresentationState * m_presentationState;

		virtual bool parseSpecific( const OFString & type, const OFString & annSpecific ) = 0;

		virtual bool createCompound() = 0;
		virtual bool createSimple() = 0;
		virtual bool createText() = 0;

	public:
		Annotation( PresentationState * presentationState );
		virtual ~Annotation();

		bool process( const OFString & line );
};


}

#endif /* ANNOTATION_H_ */
