/*
 * Component: iface
 *
 * Description:
 *     Prototypes of commonly used functions
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */

#ifndef IFACE_COMMON_H_INCLUDED
#define IFACE_COMMON_H_INCLUDED

#include <dcmtk/ofstd/ofstd.h>
#include <dcmtk/dcmdata/dctk.h>

/**
 * Prototypes of commonly used functions
 */

void getCurrentDateTime( char *cdate, char *ctime );

int checkAndCreateStudyDir( const char *studyIUID );

void removeStudyDir( const char * studyIUID );

DcmElement * addNewElement( DcmItem * item, const DcmTagKey & key, const char * value );

bool initializePbRDataset( DcmDataset * pbrDataset, const char * studyIUID, const char * pbrIUID );

bool initializePbDDataset( DcmDataset * pbdDataset, const char * studyIUID, const char * pbdIUID );

void setLastModified( DcmDataset * dataset );

OFCondition putValueFromFile( DcmElement * elem, const char * fileName, OFBool & isChanged );

bool applyElementChanges( DcmItem * item, DcmElement * elem, OFBool & isChanged );

bool isOrderIUID( const char * studyIUID );

#endif								  // IFACE_COMMON_H_INCLUDED
