/*
 * Component: sr
 *
 * Description:
 *  Header file for helper function definitions
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */
#ifndef SR_HELPER_H_INCLUDED
#define SR_HELPER_H_INCLUDED

#include <stdio.h>

#include <dcmtk/dcmdata/dctk.h>

OFBool ul2str36(unsigned long ul, char * str, int len);
char * generateID(char * id, char endChar, int len);
OFBool copyValue(DcmElement * elem, DcmElement * modElem);
OFBool isTheSameValue(const char * value1, const char * value2);
OFBool isTheSameValue(Uint8 * value1, Uint32 length1, Uint8 * value2, Uint32 length2);
OFBool modifyElementInItem(DcmItem * item, DcmElement * elem, OFBool createOnly);
void addInstanceCreationAttributes(DcmItem & item);

char * URLEncode(const char * src, const char * safeChars = NULL);
size_t URLDecode(void * pString);
size_t EncodeBinary(void * pBinary, size_t nBinary, void * pString);
void printUrlEncoded(FILE * output, const char * name, const char * value);
void printUrlEncodedWithMask(FILE * output, const char * value, const char * maskname, ...);
void printUrlEncoded(FILE * output, DcmItem * item, DcmTagKey key, char * name);
void printUrlEncodedTag(FILE * output, DcmItem * item, DcmTagKey key, const char * maskname, ...);

int isValidDerivedFile(char * srcFileName, char * drvFileName);

#endif								  // SR_HELPER_H_INCLUDED
