#ifndef __PATIENT_IFACE_H_INCLUDED__
#define __PATIENT_IFACE_H_INCLUDED__

#include <dcmtk/ofstd/ofset.h>

#include "common.h"
#include "IMLogger.h"

class IMPatientIface {
	private:
		IMLogger m_logger;
		OFString m_hl7ConfigFile;

		bool updatePatient( DcmDataset * dataset, const char * patientID, const char * userid, const char * device, OFSet<OFString> & ownerDevices );

	public:
		IMPatientIface();
		virtual ~IMPatientIface();

		int update( DcmDataset * dataset, const char * userid, const char * device, OFSet<OFString> & ownerDevices );
		int merge( DcmDataset * dataset, const char * priorPatientID, const char * userid, const char * device, OFSet<OFString> & ownerDevices );

		int processHL7Update( DcmDataset * dataset, const char * deviceID, OFSet<OFString> & ownerDevices );
		int processHL7Merge( DcmDataset * dataset, const char * priorPatientID, const char * deviceID, OFSet<OFString> & ownerDevices );
};

#endif // __PATIENT_IFACE_H_INCLUDED__
